.\"	$NetBSD: truncate.2,v 1.24 2008/03/10 12:25:55 wiz Exp $
.\"
.\" Copyright (c) 1983, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)truncate.2	8.1 (Berkeley) 6/4/93
.\"
.Dd March 16, 2008
.Dt TRUNCATE 2
.Os
.Sh NAME
.Nm truncate ,
.Nm ftruncate
.Nd truncate a file to a specified length
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In unistd.h
.Ft int
.Fn truncate "const char *path" "off_t length"
.Ft int
.Fn ftruncate "int fd" "off_t length"
.Sh DESCRIPTION
.Fn truncate
causes the file named by
.Fa path
or referenced by
.Fa fd
to have a size of
.Fa length
bytes.
If the file previously was larger than this size, the extra data is discarded.
If it was previously shorter than
.Fa length ,
its size is increased to the specified value and
the extended area appears as if it were zero-filled.
.Pp
With
.Fn ftruncate ,
the file must be open for writing; for
.Fn truncate ,
the process must have write permissions for the file.
.Sh RETURN VALUES
A value of 0 is returned if the call succeeds.
If the call fails a \-1 is returned, and the global variable
.Va errno
specifies the error.
.Sh ERRORS
Error return codes common to
.Fn truncate
and
.Fn ftruncate
are:
.Bl -tag -width Er
.It Bq Er EISDIR
The named file is a directory.
.It Bq Er EROFS
The named file resides on a read-only file system.
.It Bq Er ETXTBSY
The file is a pure procedure (shared text) file that is being executed.
.It Bq Er EIO
An I/O error occurred updating the inode.
.It Bq Er ENOSPC
There was no space in the filesystem to complete the operation.
.El
.Pp
Error codes specific to
.Fn truncate
are:
.Bl -tag -width Er
.It Bq Er ENOTDIR
A component of the path prefix is not a directory.
.It Bq Er ENAMETOOLONG
A component of a pathname exceeded
.Dv {NAME_MAX}
characters, or an entire path name exceeded
.Dv {PATH_MAX}
characters.
.It Bq Er ENOENT
The named file does not exist.
.It Bq Er EACCES
Search permission is denied for a component of the path prefix, or
the named file is not writable by the user.
.It Bq Er ELOOP
Too many symbolic links were encountered in translating the pathname.
.It Bq Er EFAULT
.Fa path
points outside the process's allocated address space.
.El
.Pp
Error codes specific to
.Fn ftruncate
are:
.Bl -tag -width Er
.It Bq Er EBADF
The
.Fa fd
is not a valid descriptor.
.It Bq Er EINVAL
The
.Fa fd
references a socket, not a file, or
the
.Fa fd
is not open for writing.
.El
.Sh SEE ALSO
.Xr open 2
.Sh STANDARDS
Use of
.Fn truncate
to extend a file is an
.St -p1003.1-2004
extension, and is thus not portable.
Files can be extended in a portable way seeking (using
.Xr lseek 2 )
to the required size and writing a single character with
.Xr write 2 .
.Sh HISTORY
The
.Fn truncate
and
.Fn ftruncate
function calls appeared in
.Bx 4.2 .
.Sh BUGS
These calls should be generalized to allow ranges
of bytes in a file to be discarded.
